#include "PhongShader.hpp"
#include "CVector.hpp"
#include "Renderer.hpp"
#include "Primative.hpp"
#include <iostream>
using namespace std;
PhongShader::PhongShader() {
	type  = S_PHONG;
}
void PhongShader::setEnvShader (Shader *s) {
	env=s;
}
void PhongShader::ShaderFunc (map <long, Light*> p, Shading_Info *s) {
	map <long, Light*>::iterator it;
	float shading = 0.0f;
	for (it = p.begin(); it != p.end(); it++) {
		CVector vDir (s->IntersectionPoint.getInternal()->x - p[it->first]->position.getInternal()->x,s->IntersectionPoint.getInternal()->y - p[it->first]->position.getInternal()->y, s->IntersectionPoint.getInternal()->z - p[it->first]->position.getInternal()->z);
		vDir.Normalize();
		float colors[3];
		s->emit = 0;
		
		float DotProd = s->Normal * vDir;
		if (DotProd < 0) {
			s->color.r = s->color.r * s->emit; // 0
			s->color.g = s->color.g * s->emit;
			s->color.b = s->color.b * s->emit;
			return;
		}
		
		shading += diff * DotProd;
		Renderer *rend = (Renderer *) s->rend;
		Primative *pa = (Primative*) s->parent;
		
		if (pa != NULL) { // if this is false.. we've got big issues
			//Create a ray from us to the light

			Ray ray(s->IntersectionPoint, p[it->first]->position);
			Shading_Info ri;	
	
		
	
	
	
		if (pa->doIntersect (&ri, &ray)) {
		if (rend != NULL) { //REALLY big issues if this is not true
		
			RTInfo rinf;
		 	rinf.shadowTrace = true; // for optimization l8r
		 	rinf.lightpos = p[it->first]->position;
		 	rinf.vExclude = ri.IntersectionPoint;
			if(rend->ShadowTrace (&ray, &	rinf, pa)) {
	

			
				//cout << "A SHADOW!" << endl;
				s->color.r = 0; s->color.g = 0; s->color.b = 0; continue; // it's a shadow
			}	
		}
	}	
		}
	
	
	

// Reflections are coming soon so h/o
		if (env != NULL) {
	
	
			env->doShader(p,s);
		}
	
	
		// Specular time.
		/*
	  	reflection.x = dir.x - (2 * normal.x * DotProd);
  		reflection.y = dir.y - (2 * normal.y * DotProd);
  		reflection.z = dir.z - (2 * normal.z * DotProd);
*/

	CVector vRef (vDir.getInternal()->x + (2* s->Normal.getInternal()->x * DotProd),vDir.getInternal()->y + (2* s->Normal.getInternal()->y * DotProd) ,vDir.getInternal()->z + (2* s->Normal.getInternal()->z * DotProd));
	float rAngle = vRef * vDir;
	float power = (float) pow (rAngle, shiny);
	shading +=spec  * power;
	if (shading > 1.0) { shading = 1.0;} 
		s->color.r = s->color.r * shading;
		s->color.g = s->color.g * shading;
		s->color.b = s->color.b * shading;
	}
	}
