#include "Shader.hpp"
#include "PhongShader.hpp"
#include "DiffuseShader.hpp"
#include "ReflectionShader.hpp"
Shader::Shader() {
	type = S_NONE;
}
void Shader::ShaderFunc(map <long, Light*> p, Shading_Info *s) {
	s->color.r=0; s->color.g=0; s->color.b=0;
}
long Shader::getType() {
	return type;
}

void Shader::doShader (map <long, Light*> p, Shading_Info*s) {
	switch (this->getType()) {
			
		case S_PHONG :
			{
				PhongShader *sh = (PhongShader *)this;
				sh->ShaderFunc(p,s);
			}
			break;
		case S_REF:
			{
				ReflectionShader *sh = (ReflectionShader*)this;
				sh->ShaderFunc (p,s);	
			}
			break;
	}
}
