#ifndef SHADER_HPP_TZURAY
#define SHADER_HPP_TZURAY
#define S_PLUGIN -2
#define S_NONE -1
#define S_DIFFUSE 0
#define S_PHONG 1
#define S_LAMBERT 2
#define S_REF 3

#include "base.hpp"
#include "PointLight.hpp"
#include "Ray.hpp"
#include <map>
using namespace std;
class Primative;
class Renderer;
struct Intersection;
#include "rgbSurface.h"

struct Shading_Info {
	rgb24 color;
	float fColor;
	byte alpha;
	CVector IntersectionPoint;
	CVector Normal;	
	float emit;
	Ray *r;
	Intersection **i;
	long numIsct;
	float dist;
	Renderer *rend;
	Primative *parent;
};
class Shader {
	protected:
	long type;
	public:
	Shader();
	long getType();
	void ShaderFunc(map <long, Light*> p, Shading_Info *);
	void doShader (map <long, Light*> p, Shading_Info*);
};

#endif

