#include "Sphere.hpp"
#include <iostream>
#include "base.hpp"
using namespace std;
#include <math.h>
Sphere::Sphere () {
	type = P_SPHERE;
}
Sphere::Sphere(CVector center, float r) {
	position = center; radius = r;
	type = P_SPHERE;
}
float Sphere::getRadius() {
	return radius;
}
void Sphere::setRadius(float r) {
	radius = r;
}

bool Sphere::Intersect (Shading_Info *s, Ray *r) {
		
		
		CVector v = r->vStart - position;
		
		float p = (r->vDir * (v));
		float q = (v*v) - radius*radius;
		float px = p*p - q;
		float py = p*p + q;
		Intersection *i, *i2;
			
		long numIsct=0;
		if (px > 0) {
			i = new Intersection;
			float t = sqrt(px);
			i->point = r->vStart + r->vDir *t;
			//i->normal = (i->point - position)/radius;
			i->color = color;
			i->dist = t;
			i->ray = r;
			i->object = this;
			isctlist.add(i);
			numIsct++;
			
		} // we hit once
		if (py > 0) {
		
		i2 = new Intersection;
			float t = sqrt(py);
			i2->point = r->vStart + r->vDir *t;
			//i2->normal = (i->point - position)/radius;
			i2->color = color;
			i2->dist = t;
			i2->ray = r;
			i2->object = this;
			isctlist.add(i2);
			numIsct++;
		} // we hit twice
		if (numIsct == 0) { return false; }
		if (numIsct == 1) {
			s->i = new Intersection* [0];
			s->i[0] = i;
			s->numIsct = numIsct;
			return true;
		}
		if (numIsct == 2) {
			
			s->i = new Intersection* [1];
			s->i[0] = i;
			s->i[1] = i2;
			s->numIsct = numIsct;
			return true;
		}
		
  		/*
		float b = r->vDir * v;
   		float D = b*b - (v.getInternal()->x*v.getInternal()->x + v.getInternal()->y*v.getInternal()->y + v.getInternal()->z*v.getInternal()->z - radius);
   		if(D < 0) {return false;} else {
   		D = sqrtf(D);		
		float D1 = b + D;
		Intersection *i   = new Intersection;
		s->i = new Intersection* [1];
		i->dist = D1;
		i->point = r->vStart+r->vDir*D1;
		i->normal = (i->point - position) / radius;
		i->ray = r;
		i->object= this;
		i->color = color;		
		isctlist.add(i);
		s->i[0] = i;
		i = new Intersection;
		float D2= b - D;
		i->dist = D2;
		i->point = r->vStart+r->vDir*D2;
		i->normal = (i->point - position) / radius;
		i->ray = r;
		i->object= this;
		i->color = color;
		s->i[1] = i;
		isctlist.add(i);	
		s->numIsct = 2;
		
			return true;
		
		
			} // We have a hit!! I repeat we have a hit w00tage!
	 */
	 }
// void Sphere::get_intersections(const Ray &ray, ISList &islist) {
   
   //islist.add_intersection(this, b-D);
   //islist.add_intersection(this, b+D);
 //}


