#include "TclInput.hpp"
#include "PhongShader.hpp"
#include "ReflectionShader.hpp"
#include <stdio.h>
#include <tcl.h>
Tcl_Interp *interp;
Scene *scene;
Renderer *rend;

/*typedef int Tcl_ObjCmdProc(
	ClientData clientData,
	Tcl_Interp *interp,
	int objc,
	Tcl_Obj *CONST objv[]);*/
map <long, Shader *> shaders;
long numLights;
int ADDLIGHT (ClientData clientData,Tcl_Interp *interp,int objc,Tcl_Obj *CONST objv[]) {
	if (objc < 3) {
		return TCL_BREAK;
	
	} else {
		double x,y,z;
	Tcl_GetDoubleFromObj (interp, objv[1], &x);
		Tcl_GetDoubleFromObj (interp, objv[2], &y);
		Tcl_GetDoubleFromObj (interp, objv[3], &z);
	        
		scene->p[numLights] = new PointLight ();
		scene->p[numLights]->position = CVector (x,y,z);
		numLights++;
		return TCL_OK;
	}
	}
int SETSKYCOLOR(ClientData clientData,Tcl_Interp *interp,int objc,Tcl_Obj *CONST objv[]) {
 	if (objc < 3) {
	return TCL_BREAK;
	}
	else {
	long r,g,b;
	Tcl_GetLongFromObj (interp, objv[1], &r);
	Tcl_GetLongFromObj (interp, objv[2], &g);
	Tcl_GetLongFromObj (interp, objv[3], &b);
	rgb24 color;
	color.r = r; color.g = g; color.b = b;
	scene->skycolor = color;
	return TCL_OK;
	}
 }
 
 int PUTSPHERE(ClientData clientData,Tcl_Interp *interp,int objc,Tcl_Obj *CONST objv[]) {
 	if (objc < 8) {
		return TCL_BREAK;
	} else {
		double x,y,z,rad;
		long r,g,b,sh;
		
		Tcl_GetDoubleFromObj (interp, objv[1], &x);
		Tcl_GetDoubleFromObj (interp, objv[2], &y);
		Tcl_GetDoubleFromObj (interp, objv[3], &z);
		Tcl_GetDoubleFromObj (interp, objv[4], &rad);
		Tcl_GetLongFromObj (interp, objv[5], &r);
		Tcl_GetLongFromObj (interp, objv[6], &g);
		Tcl_GetLongFromObj (interp, objv[7], &b);
		Tcl_GetLongFromObj (interp, objv[8], &sh);
		Sphere *s= new Sphere(CVector(x,y,z),rad);
		rgb24 color = {r,g,b};
		s->color = color;
		s->shader = shaders[sh];
		scene->AddObject (s);
		return TCL_OK;
	}
 }
 
int PUTPLANE(ClientData clientData,Tcl_Interp *interp,int objc,Tcl_Obj *CONST objv[]) {
 	if (objc < 8) {
		return TCL_BREAK;
	} else {
		double x,y,z,dist;
		long r,g,b,sh;
		Tcl_GetDoubleFromObj (interp, objv[1], &x);
		Tcl_GetDoubleFromObj (interp, objv[2], &y);
		Tcl_GetDoubleFromObj (interp, objv[3], &z);
		Tcl_GetDoubleFromObj (interp, objv[4], &dist);
		Tcl_GetLongFromObj (interp, objv[5], &r);
		Tcl_GetLongFromObj (interp, objv[6], &g);
		Tcl_GetLongFromObj (interp, objv[7], &b);
		Tcl_GetLongFromObj (interp, objv[8], &sh);
		Plane *s = new Plane(CVector(x,y,z),dist);
		rgb24 color = {r,g,b};
		s->color = color;
		s->shader = shaders[sh];
		scene->AddObject (s);
		return TCL_OK;
	}
 }
 
 int REFLECTIONSHADER(ClientData clientData,Tcl_Interp *interp,int objc,Tcl_Obj *CONST objv[]) {  
 	if (objc < 1) {
		return TCL_OK; // w000t
	}
	else
	{
		long id;
		Tcl_GetLongFromObj (interp, objv[1], &id);
		ReflectionShader *s  = new ReflectionShader ();
		shaders[id] = s;
		return TCL_OK;
	}
 }
 int SETCHILDSHADER(ClientData clientData,Tcl_Interp *interp,int objc,Tcl_Obj *CONST objv[]) {  
 	if (objc < 2) {
		return TCL_BREAK;
	} else {
		long id1, id2;
		Tcl_GetLongFromObj (interp, objv[1], &id1);
		Tcl_GetLongFromObj (interp, objv[2], &id2);
		if (shaders[id1]->getType() == S_PHONG) {
			PhongShader *s = (PhongShader*) shaders[id1];
			s->setEnvShader (shaders[id2]);
		}
		
		return TCL_OK;
	}
 }
 int PHONGSHADER(ClientData clientData,Tcl_Interp *interp,int objc,Tcl_Obj *CONST objv[]) { 
 	if (objc < 4) {
		return TCL_BREAK;
	}else{
		double diff, spec, shiny;
		long id;
		Tcl_GetLongFromObj (interp, objv[1], &id);
		Tcl_GetDoubleFromObj (interp, objv[2], &diff);
		Tcl_GetDoubleFromObj (interp, objv[3], &spec);
		Tcl_GetDoubleFromObj (interp, objv[4], &shiny);
		PhongShader *ps = new PhongShader();
		ps->diff = diff;
		ps->spec = spec;
		ps->shiny = shiny;
		shaders[id] = ps;
		return TCL_OK;
	}
 }
int SETVIEW(ClientData clientData,Tcl_Interp *interp,int objc,Tcl_Obj *CONST objv[]) { 
	if (objc < 6) {
	return TCL_BREAK;
	}
	else {
	double x,y,z,lookx,looky,lookz;
		Tcl_GetDoubleFromObj (interp, objv[1], &x);
		Tcl_GetDoubleFromObj (interp, objv[2], &y);
		Tcl_GetDoubleFromObj (interp, objv[3], &z);
		Tcl_GetDoubleFromObj (interp, objv[4], &lookx);
		Tcl_GetDoubleFromObj (interp, objv[5], &looky);
		Tcl_GetDoubleFromObj (interp, objv[6], &lookz);
		rend->theView.position = CVector(x,y,z);
		rend->theView.lookat = CVector(x,y,z);
		return TCL_OK;
	}
}
void InitInput (Renderer *r) {
	scene = &r->scene;
	rend = r;
	interp = Tcl_CreateInterp();
	Tcl_CreateObjCommand(interp, "SETSKYCOLOR", SETSKYCOLOR, NULL, NULL);
	Tcl_CreateObjCommand(interp, "PUTSPHERE", PUTSPHERE, NULL, NULL);
	Tcl_CreateObjCommand(interp, "PUTPLANE", PUTPLANE, NULL, NULL);
	Tcl_CreateObjCommand(interp, "PHONGSHADER", PHONGSHADER, NULL, NULL);
	Tcl_CreateObjCommand(interp, "REFLECTIONSHADER", REFLECTIONSHADER, NULL, NULL);
	Tcl_CreateObjCommand(interp, "SETCHILDSHADER", SETCHILDSHADER, NULL, NULL);
	Tcl_CreateObjCommand(interp, "SETVIEW", SETVIEW, NULL, NULL);
	Tcl_CreateObjCommand(interp, "ADDLIGHT", ADDLIGHT, NULL, NULL);
}
void ExecFile (const char *file) {
	FILE *f = fopen(file, "r");
	fseek (f,0,SEEK_END);
	long flen = ftell(f);
	fseek (f,0,SEEK_SET);
	
	char *data = new char [flen];
	fread (data, 1, flen, f);
	fclose(f);
	Tcl_Eval (interp, data);
	
	delete data;
}

