class ads_shader: public shader
{
  double ambient, diffuse, specular, spec_exp;

  colour get_shade(vector & pt, appearance & app, vector & nrm, vector & 
warp_nrm,
    ray & view_ray, vector & light_position, colour & light_colour, 
colour & shadow)
  {
    vector unit_u, unit_nrm, point_to_light, half_v;
    colour ret;
    double diff_iny, spec_iny, n_dot_u, n_dot_l;

    unit_u = unit_v(view_ray.u);
    unit_nrm = unit_v(nrm);

    point_to_light = unit_v(light_position - pt);

    // determine if light and viewing position are on same side of 
surface
    n_dot_u = unit_nrm * unit_u;
    n_dot_l = unit_nrm * point_to_light;

    if ((n_dot_u > 0 && n_dot_l < 0) || (n_dot_u < 0 && n_dot_l > 0))
    {
      // calculate diffuse intensity
      diff_iny = diffuse * fabs(warp_nrm * point_to_light);

      // calculate half-way vector
      half_v = unit_v(point_to_light - unit_u);

      // calculate specular intensity
      spec_iny = specular * pow(fabs(warp_nrm * half_v), spec_exp);

      ret.r = (diff_iny * shadow.r + ambient) * light_colour.r * 
app.colour.r;
      ret.g = (diff_iny * shadow.g + ambient) * light_colour.g * 
app.colour.g;
      ret.b = (diff_iny * shadow.b + ambient) * light_colour.b * 
app.colour.b;

      ret = ret + (spec_iny * shadow * light_colour);
    }
    else
      ret = ambient * light_colour * app.colour;

    return ret;
  }
};
