#include "PhongShader.hpp"
#include "Renderer.hpp"
PhongShader::PhongShader() {
	type  = S_PHONG;
}
void PhongShader::ShaderFunc (PointLight *p, Shading_Info *s) {
	CVector vDir (s->IntersectionPoint.getInternal()->x - p->position.getInternal()->x,s->IntersectionPoint.getInternal()->y - p->position.getInternal()->y, s->IntersectionPoint.getInternal()->z - p->position.getInternal()->z);
	vDir.Normalize();
	float colors[3];
	s->emit = 0;
	float shading = 0.0f;
	float DotProd = s->Normal * vDir;
	if (DotProd < 0) {
		s->color.r = s->color.r * s->emit; // 0
		s->color.g = s->color.g * s->emit;
		s->color.b = s->color.b * s->emit;
		return;
	}
	shading += diff * DotProd;
	Renderer *rend = (Renderer *) s->rend;
	if (rend != NULL) {
	//Create a ray from teh light to us
	Ray ray(p->position, s->IntersectionPoint);
	RTInfo ri;
	rend->RayTrace(&ray, &ri);
	/*
	if ((ri.intersected) && (ri.isctshort != s->IntersectionPoint)) {
		s->color.r = 0;
		s->color.g = 0;
		s->color.b = 0;
		return;
	}
	}
	Not needed... gonna put shadowrays in Renderer::RayTrace.. makes it easier
	*/
// Reflections are coming soon so h/o
	
	s->color.r = s->color.r * shading;
	s->color.g = s->color.g * shading;
	s->color.b = s->color.b * shading;
	
	// Specular time.
	/*
	  reflection.x = dir.x - (2 * normal.x * DotProd);
  reflection.y = dir.y - (2 * normal.y * DotProd);
  reflection.z = dir.z - (2 * normal.z * DotProd);
*/

CVector vRef (vDir.getInternal()->x - (2* s->Normal.getInternal()->x * DotProd),vDir.getInternal()->y - (2* s->Normal.getInternal()->y * DotProd) ,vDir.getInternal()->z - (2* s->Normal.getInternal()->z * DotProd));
float rAngle = vRef * vDir;
float power = (float) pow (rAngle, shiny);
shading +=spec  * power;
	
};
