#include "Renderer.hpp"
#include "Sphere.hpp"
#include "Plane.hpp"
#include "PointLight.hpp"
#include "DiffuseShader.hpp"
#include "Primative.hpp"
#include "PhongShader.hpp"
#include <iostream>
using namespace std;
Renderer::Renderer() {
}

rgb24 Renderer::RayTrace (Ray *r, RTInfo *in) {
	map <long, float> dbuffer;
	map <long, rgb24> cbuffer;
	map <long, CVector> ibuffer;
	long nObjects = scene.getNumObjects();
	Shading_Info inf;
	inf.rend = this;
	DiffuseShader* shd;
	PhongShader * shp;
	Primative *pri;
	Sphere *s;
	in->intersected = false; // just in case we dont have anythin in the scene
	Plane *p;
	rgb24 rg;
	long z=0; // # of intesections
	for (long i = 0; i < nObjects; i++) {
		
		pri = scene.getObject(i);
		if (pri == NULL) {continue;}
		
		switch (pri->getType()) {
		case P_SPHERE:
		
		s = (Sphere *)pri;
			
			if (s->Intersect (&inf,r)) {				
				dbuffer[z] = inf.dist;
				ibuffer[z] = inf.IntersectionPoint;
				in->intersected = true;
				
				switch (s->shader->getType()) {
					case S_DIFFUSE:
						 shd= (DiffuseShader*)s->shader;
						shd->ShaderFunc(&scene.p, &inf);
						
						break;
					case S_PHONG:
						shp = (PhongShader*)s->shader;
						shp->ShaderFunc(&scene.p, &inf);
						
						break;
					default:

						rg.r=0;rg.g=0;rg.b=0;
						inf.color = rg;
						break;
				}
				
				cbuffer[z] = inf.color;
				z++;
			}
			else {
				if (!in->intersected) { // We havent hit anything yet
				in->intersected = false;
				}
			}
			
			break;
		case P_PLANE:
			p = (Plane *) pri;
			if (p->Intersect (&inf,r)) {
			ibuffer[z] = inf.IntersectionPoint;
				dbuffer[z] = inf.dist;
				
				in->intersected = true;
				
				switch (p->shader->getType()) {
					case S_DIFFUSE:
						
						shd=(DiffuseShader*)p->shader;
						shd->ShaderFunc(&scene.p, &inf);
						
						break;
					case S_PHONG:
						
						shp = (PhongShader *)p->shader;
						shp->ShaderFunc(&scene.p, &inf);
						
						break;
					default:
						
						rg.r=0;rg.g=0;rg.b=0;
						return rg;
						break;
				}
				inf.color = rg;
				cbuffer[z] = inf.color;
				z++;
			}
			else {
			if (!in->intersected) { // We havent hit anything yet
				in->intersected = false;
				}
			}
		break;
		}
		
	}

if (!in->intersected) { return scene.skycolor;}else {
long f=0;
long lowest=0; // get nearest color;

for (f=0; f < z; f++) {

if (dbuffer[f] < dbuffer[lowest]) {
	lowest = f;
	in->shortest = dbuffer[f];
	in->isctshort = ibuffer[f];
}
}

return cbuffer[lowest];
}
}
void Renderer::Render(int w, int h, rgbSurface *rgb) {
rgb->w = w;
rgb->h = h;
rgb->data = new rgb24 [w*h];
Primative *prim;
RTInfo	ri;
rgb24 color;

for (int x=0; x < w; x++) {
	
	for (int y=0; y < h; y++) {
		
		float cx = (x - (w /2)) + theView.position.getInternal()->x; // Translate our pixels
		float cy = (y - (h/2)) + theView.position.getInternal()->y; // Translate our pixels
		Ray r(theView.position, CVector(cx,cy,theView.lookat.getInternal()->z)); // shoot our ray!!! w00tage

		color = RayTrace (&r, &ri);
		rgb->data [(rgb->w *y)  +x] = color;
	}
}
	
}
